<div class="container scheduler-segment">
  <h1>{{ 'scheduling.config.headline' | translate }}</h1>

  <div class="flex-container">
    <input
      id="processNameUser"
      class="form-control configInput"
      [ngClass]="{ 'is-invalid': showConfigParseError }"
      [(ngModel)]="configurationString"
      placeholder="{{ 'scheduling.config.useconfighint' | translate }}"
    />
    <span class="apply">
      <button
        type="button"
        style="width: 100%"
        class="btn btn-primary"
        (click)="useConfig()"
        [disabled]="configurationString === ''"
      >
        <fa-icon [icon]="faAlignJustify"></fa-icon>
        {{ 'scheduling.config.useconfigbutton' | translate }}
      </button>
    </span>
  </div>

  <div *ngIf="showConfigParseError" style="text-align: center; color: var(--danger-color)">
    {{ 'scheduling.config.useconfigerror' | translate }}
  </div>

  <div class="flex-container" style="width: 100%; margin-top: 8px; margin-bottom: 16px">
    <select
      class="form-select configInput"
      [(ngModel)]="diagram.strategyHelper"
      (ngModelChange)="onStrategyChange($event)"
    >
      <option value="{{ Strategies.FCFS }}">{{ 'scheduling.config.strategyDescription.fcfstitle' | translate }}</option>
      <option value="{{ Strategies.SJF }}">{{ 'scheduling.config.strategyDescription.sjftitle' | translate }}</option>
      <option value="{{ Strategies.SRTN }}">{{ 'scheduling.config.strategyDescription.srtntitle' | translate }}</option>
      <option value="{{ Strategies.Priority }}">
        {{ 'scheduling.config.strategyDescription.priotitle' | translate }}
      </option>
      <option value="{{ Strategies.EDF }}">{{ 'scheduling.config.strategyDescription.edftitle' | translate }}</option>
      <option value="{{ Strategies.RR }}">{{ 'scheduling.config.strategyDescription.rrtitle' | translate }}</option>
    </select>

    <span class="apply">
      <button type="button" style="width: 100%" class="btn btn-secondary" (click)="displayStrategyDescription()">
        <fa-icon [icon]="faQuestion"></fa-icon>
        {{ 'scheduling.diagram.help' | translate }}
      </button>
    </span>
  </div>

  <div
    *ngIf="strategyDescription != ''"
    title="{{ 'scheduling.config.strategyDescription.description' | translate }}"
    class="alert alert-dismissible alert-secondary textwithnewline"
    style="margin-top: 32px; word-break: break-word"
  >
    <button type="button" class="btn-close" data-bs-dismiss="alert" (click)="toggleConfigurationActivated()"></button>

    <h4 class="alert-heading">{{ strategyTitle }}</h4>
    {{ strategyDescription }}
  </div>

  <label class="label-description config-item" for="config-advanced-container">{{
    'scheduling.config.options.label' | translate
  }}</label>
  <div class="btn-group config-item" id="config-advanced-container">
    <input
      class="btn-check"
      id="configurationPossibilitiesSimple"
      name="configurationPossibilities"
      type="radio"
      [value]="false"
      [(ngModel)]="diagram.advancedConfigurationOptions"
    />
    <label class="btn btn-outline-primary" for="configurationPossibilitiesSimple">{{
      'scheduling.config.options.simple' | translate
    }}</label>

    <input
      class="btn-check"
      id="configurationPossibilitiesAdvanced"
      name="configurationPossibilities"
      type="radio"
      [value]="true"
      [(ngModel)]="diagram.advancedConfigurationOptions"
    />
    <label class="btn btn-outline-primary" for="configurationPossibilitiesAdvanced">{{
      'scheduling.config.options.advanced' | translate
    }}</label>
  </div>

  <label class="label-description config-item" *ngIf="diagram.strategy == Strategies.RR" for="input_slicelength">{{
    'scheduling.config.timeslicelength.label' | translate
  }}</label>
  <input
    *ngIf="diagram.strategy == Strategies.RR"
    id="input_slicelength"
    type="number"
    onkeydown="return false"
    [(ngModel)]="diagram.timeSliceLength"
    min="1"
    class="config-item"
    (ngModelChange)="diagram.updateCorrectionStatus()"
  />

  <label
    class="label-description config-item"
    *ngIf="
      diagram.strategy == Strategies.Priority ||
      diagram.strategy == Strategies.Priority_dynamic ||
      diagram.strategy == Strategies.EDF
    "
    for="preemptiveSetting"
    >{{ 'scheduling.config.preemptive.label' | translate }}</label
  >
  <div
    *ngIf="
      diagram.strategy == Strategies.Priority ||
      diagram.strategy == Strategies.Priority_dynamic ||
      diagram.strategy == Strategies.EDF
    "
    class="config-item btn-group"
  >
    <input
      class="btn-check"
      id="nonpreemptiveSetting"
      name="preemptiveSetting"
      type="radio"
      [value]="false"
      [(ngModel)]="diagram.preemptive"
      (ngModelChange)="diagram.updateCorrectionStatus()"
    />
    <label class="btn btn-outline-primary" for="nonpreemptiveSetting">{{
      'scheduling.config.preemptive.non' | translate
    }}</label>
    <input
      class="btn-check"
      id="preemptiveSetting"
      name="preemptiveSetting"
      type="radio"
      [value]="true"
      [(ngModel)]="diagram.preemptive"
      (ngModelChange)="diagram.updateCorrectionStatus()"
    />
    <label class="btn btn-outline-primary" for="preemptiveSetting">{{
      'scheduling.config.preemptive.preemptive' | translate
    }}</label>
  </div>

  <label
    class="label-description config-item"
    *ngIf="diagram.strategy == Strategies.Priority || diagram.strategy == Strategies.Priority_dynamic"
    for="dynamicprioritySpecification"
    >{{ 'scheduling.config.priority.label' | translate }}
  </label>
  <div
    *ngIf="diagram.strategy == Strategies.Priority || diagram.strategy == Strategies.Priority_dynamic"
    class="config-item btn-group"
  >
    <input
      class="btn-check"
      id="staticprioritySpecification"
      name="prioritySpecification"
      type="radio"
      [value]="false"
      [(ngModel)]="dynamicHelper"
      (ngModelChange)="diagram.updateCorrectionStatus(); updatedynamicStatic($event)"
    />
    <label class="btn btn-outline-primary" for="staticprioritySpecification">{{
      'scheduling.config.priority.static' | translate
    }}</label>
    <input
      class="btn-check"
      id="dynamicprioritySpecification"
      name="prioritySpecification"
      type="radio"
      [value]="true"
      [(ngModel)]="dynamicHelper"
      (ngModelChange)="diagram.updateCorrectionStatus(); updatedynamicStatic($event)"
    />
    <label class="btn btn-outline-primary" for="dynamicprioritySpecification">{{
      'scheduling.config.priority.dynamic' | translate
    }}</label>
  </div>

  <label
    class="label-description config-item"
    *ngIf="
      (diagram.strategy == Strategies.Priority || diagram.strategy == Strategies.Priority_dynamic) &&
      diagram.advancedConfigurationOptions
    "
    for="lowPrioritySpecification"
    >{{ 'scheduling.config.priorityorder.label' | translate }}
  </label>
  <div
    *ngIf="
      (diagram.strategy == Strategies.Priority || diagram.strategy == Strategies.Priority_dynamic) &&
      diagram.advancedConfigurationOptions
    "
    class="config-item btn-group"
  >
    <input
      class="btn-check"
      id="highPrioritySpecification"
      name="priorityOrderSpecification"
      type="radio"
      [value]="false"
      [(ngModel)]="diagram.lowestPriorityFirst"
      (ngModelChange)="diagram.updateCorrectionStatus()"
    />
    <label class="btn btn-outline-primary" for="highPrioritySpecification">{{
      'scheduling.config.priorityorder.highest' | translate
    }}</label>
    <input
      class="btn-check"
      id="lowPrioritySpecification"
      name="priorityOrderSpecification"
      type="radio"
      [value]="true"
      [(ngModel)]="diagram.lowestPriorityFirst"
      (ngModelChange)="diagram.updateCorrectionStatus()"
    />
    <label class="btn btn-outline-primary" for="lowPrioritySpecification">{{
      'scheduling.config.priorityorder.lowest' | translate
    }}</label>
  </div>

  <label
    class="label-description config-item"
    *ngIf="diagram.strategy == Strategies.Priority_dynamic"
    for="input_priochangeComputing"
    >{{ 'scheduling.config.dynamiccomputing.label' | translate }}
  </label>
  <input
    *ngIf="diagram.strategy == Strategies.Priority_dynamic"
    id="input_priochangeComputing"
    type="number"
    class="config-item"
    onkeydown="return false"
    [(ngModel)]="diagram.prioChangeComputing"
    step="0.1"
    (ngModelChange)="diagram.updateCorrectionStatus()"
  />

  <label
    class="label-description config-item"
    *ngIf="diagram.strategy == Strategies.Priority_dynamic"
    for="input_priochangeWaiting"
    >{{ 'scheduling.config.dynamicwaiting.label' | translate }}</label
  >
  <input
    *ngIf="diagram.strategy == Strategies.Priority_dynamic"
    id="input_priochangeWaiting"
    type="number"
    class="config-item"
    onkeydown="return false"
    [(ngModel)]="diagram.prioChangeWaiting"
    step="0.1"
    (ngModelChange)="diagram.updateCorrectionStatus()"
  />

  <label
    class="label-description config-item"
    *ngIf="diagram.advancedConfigurationOptions"
    for="initialSchedulerSetting"
    >{{ 'scheduling.config.initialscheduler.label' | translate }}</label
  >
  <div *ngIf="diagram.advancedConfigurationOptions" class="config-item btn-group">
    <input
      class="btn-check"
      id="initialSchedulerSetting"
      name="initialTimeSetting"
      type="radio"
      [value]="false"
      [(ngModel)]="diagram.initialScheduler"
      (ngModelChange)="diagram.updateCorrectionStatus()"
    />
    <label class="btn btn-outline-primary" for="initialSchedulerSetting">{{
      'scheduling.config.initialscheduler.one' | translate
    }}</label>
    <input
      class="btn-check"
      id="noInitialSchedulerSetting"
      name="initialTimeSetting"
      type="radio"
      [value]="true"
      [(ngModel)]="diagram.initialScheduler"
      (ngModelChange)="diagram.updateCorrectionStatus()"
    />
    <label class="btn btn-outline-primary" for="noInitialSchedulerSetting">{{
      'scheduling.config.initialscheduler.no' | translate
    }}</label>
  </div>

  <label class="label-description config-item" for="schedulerSetting">{{
    'scheduling.config.schedulertime.label' | translate
  }}</label>
  <div class="btn-group config-item">
    <input
      class="btn-check"
      id="schedulerSetting"
      name="schedulerTimeSetting"
      type="radio"
      [value]="true"
      [(ngModel)]="diagram.schedulerTime"
      (ngModelChange)="diagram.updateCorrectionStatus()"
    />
    <label class="btn btn-outline-primary" for="schedulerSetting">{{
      'scheduling.config.schedulertime.one' | translate
    }}</label>
    <input
      class="btn-check"
      id="noSchedulerSetting"
      name="schedulerTimeSetting"
      type="radio"
      [value]="false"
      [(ngModel)]="diagram.schedulerTime"
      (ngModelChange)="diagram.updateCorrectionStatus(); diagram.dispatcherTime = false"
    />
    <label class="btn btn-outline-primary" for="noSchedulerSetting">{{
      'scheduling.config.schedulertime.no' | translate
    }}</label>
  </div>

  <label class="label-description config-item" for="dispatcherSetting">{{
    'scheduling.config.dispatchertime.label' | translate
  }}</label>
  <div class="config-item btn-group">
    <input
      class="btn-check"
      id="dispatcherSetting"
      name="dispatcherTimeSetting"
      type="radio"
      [value]="true"
      [(ngModel)]="diagram.dispatcherTime"
      (ngModelChange)="diagram.updateDispatcherState(true)"
    />
    <label class="btn btn-outline-primary" for="dispatcherSetting">{{
      'scheduling.config.dispatchertime.one' | translate
    }}</label>
    <input
      class="btn-check"
      id="noDispatcherSetting"
      name="dispatcherTimeSetting"
      type="radio"
      [value]="false"
      [(ngModel)]="diagram.dispatcherTime"
      (ngModelChange)="diagram.updateDispatcherState(false)"
    />
    <label class="btn btn-outline-primary" for="noDispatcherSetting">{{
      'scheduling.config.dispatchertime.no' | translate
    }}</label>
  </div>

  <label class="label-description config-item" *ngIf="diagram.strategy == Strategies.RR" for="ownUserLevelScheduler">{{
    'scheduling.config.ownUserLevelScheduler.label' | translate
  }}</label>
  <div class="btn-group config-item" *ngIf="diagram.strategy == Strategies.RR">
    <input
      class="btn-check"
      id="ownUserLevelScheduler"
      name="ownUserLevelScheduler"
      type="radio"
      [value]="true"
      [(ngModel)]="diagram.ownUserLevelScheduler"
      (ngModelChange)="diagram.updateCorrectionStatus()"
    />
    <label class="btn btn-outline-primary" *ngIf="diagram.strategy == Strategies.RR" for="ownUserLevelScheduler">{{
      'scheduling.config.ownUserLevelScheduler.yes' | translate
    }}</label>
    <input
      class="btn-check"
      id="noOwnUserLevelScheduler"
      name="noOwnUserLevelScheduler"
      type="radio"
      [value]="false"
      [(ngModel)]="diagram.ownUserLevelScheduler"
      (ngModelChange)="diagram.updateCorrectionStatus()"
    />
    <label class="btn btn-outline-primary" for="noOwnUserLevelScheduler">{{
      'scheduling.config.ownUserLevelScheduler.no' | translate
    }}</label>
  </div>

  <label
    class="label-description config-item"
    *ngIf="diagram.advancedConfigurationOptions && diagram.strategy == Strategies.RR"
    for="userSchedulerSetting"
    >{{ 'scheduling.config.userschedulertime.label' | translate }}</label
  >
  <div *ngIf="diagram.advancedConfigurationOptions && diagram.strategy == Strategies.RR" class="config-item btn-group">
    <input
      class="btn-check"
      id="userSchedulerSetting"
      name="userSchedulerTimeSetting"
      type="radio"
      [value]="true"
      [(ngModel)]="diagram.userSchedulerTime"
      (ngModelChange)="diagram.updateCorrectionStatus()"
    />
    <label class="btn btn-outline-primary" for="userSchedulerSetting">{{
      'scheduling.config.userschedulertime.one' | translate
    }}</label>
    <input
      class="btn-check"
      id="noUserSchedulerSetting"
      name="userSchedulerTimeSetting"
      type="radio"
      [value]="false"
      [(ngModel)]="diagram.userSchedulerTime"
      (ngModelChange)="diagram.updateCorrectionStatus()"
    />
    <label class="btn btn-outline-primary" for="noUserSchedulerSetting">{{
      'scheduling.config.userschedulertime.no' | translate
    }}</label>
  </div>

  <!-- begin -->
  <label
    class="label-description config-item"
    *ngIf="diagram.advancedConfigurationOptions && diagram.strategy == Strategies.RR"
    for="pidRROrder"
    >{{ 'scheduling.config.rrOrder.label' | translate }}</label
  >
  <div *ngIf="diagram.advancedConfigurationOptions && diagram.strategy == Strategies.RR" class="config-item btn-group">
    <input
      class="btn-check"
      id="pidRROrder"
      name="pidRROrder"
      type="radio"
      [value]="true"
      [(ngModel)]="diagram.rrOrder"
      (ngModelChange)="diagram.updateCorrectionStatus()"
    />
    <label class="btn btn-outline-primary" for="pidRROrder">{{ 'scheduling.config.rrOrder.one' | translate }}</label>
    <input
      class="btn-check"
      id="timeRROrder"
      name="pidRROrder"
      type="radio"
      [value]="false"
      [(ngModel)]="diagram.rrOrder"
      (ngModelChange)="diagram.updateCorrectionStatus()"
    />
    <label class="btn btn-outline-primary" for="timeRROrder">{{ 'scheduling.config.rrOrder.no' | translate }}</label>
  </div>
  <!-- RR order setting end -->
  <label class="label-description config-item" *ngIf="diagram.advancedConfigurationOptions" for="inputCoreNumber"
    >{{ 'scheduling.config.computingCores.label' | translate }}
  </label>
  <input
    *ngIf="diagram.advancedConfigurationOptions"
    id="inputCoreNumber"
    type="number"
    [(ngModel)]="diagram.coreNumber"
    min="1"
    max="8"
    class="config-item"
    (ngModelChange)="diagram.updateCorrectionStatus()"
    onkeydown="return false"
    disabled
  />

  <div *ngIf="diagram.coreNumber > 1" style="text-align: center; color: var(--danger-color)">
    <br />
    {{ 'scheduling.config.computingCores.label' | translate }}
  </div>
</div>
